<template>
  <v-progress-circular
    v-if="loading"
    indeterminate
    color="accent"
    :size="40"
    :width="5"></v-progress-circular>
  <v-data-table v-else :headers="headers" :items="groups" :loading="loading">
  </v-data-table>
</template>

<script lang="ts">
import { Component, Prop, Mixins } from 'vue-property-decorator'
import ApiAccess from '@/mixins/apiAccess'
import Tanuki from './Tanuki.vue'

@Component({
  components: { Tanuki }
})
export default class GroupTable extends Mixins(ApiAccess) {
  @Prop({ default: '' })
  search!: string

  loading = false
  progress = 0
  groups = []
  unloadedGroups = []
  groupGraphqlQeue = []
  totalGroups = 0
  headers = [
    {
      text: 'Name',
      sortable: true,
      value: 'name'
    },
    {
      text: '# of Frameworks',
      sortable: true,
      value: 'countFrameworks'
    },
    {
      text: 'Actions',
      sortable: false,
      value: 'actions'
    }
  ]

  created (): void {
    this.loadGroups()
  }

  async loadGroups (): Promise<void> {
    const api = this.getRestAPI()

    let currentPage = 1
    this.groups = []
    this.unloadedGroups = []
    this.loading = true

    while (true) {
      const response:any = await api.Groups.all({
        page: currentPage,
        maxPages: 1,
        perPage: 30,
        showExpanded: true,
        top_level_only: true,
        search: ''
      })

      this.totalGroups = response.paginationInfo.total

      this.unloadedGroups = this.groups.concat(response.data)

      if (response.paginationInfo.next == null) {
        break
      } else {
        currentPage++
      }
    }

    this.groups = this.unloadedGroups
    this.unloadedGroups = []

    this.loading = false
  }
}
</script>
